Loading...
Searching...
No Matches
Ogre::TerrainLayerBlendMap Class Reference
Optional Components » Terrain

Class exposing an interface to a blend map for a given layer. More...

`#include <OgreTerrainLayerBlendMap.h>`

Inheritance diagram for Ogre::TerrainLayerBlendMap:
[legend]

## Public Member Functions

| TerrainLayerBlendMap (Terrain *parent, uint8 layerIndex, HardwarePixelBuffer *buf)
| Constructor.
virtual | ~TerrainLayerBlendMap ()
void | blit (const PixelBox &src)
| Blits a set of values into the entire map.
void | blit (const PixelBox &src, const Box &dstBox)
| Blits a set of values into a region on the blend map.
void | convertImageToTerrainSpace (size_t x, size_t y, Real *outX, Real *outY)
| Convert image space (0, imageSize) to terrain space values (0,1).
void | convertImageToUVSpace (size_t x, size_t y, Real *outX, Real *outY)
| Convert image space (0, imageSize) to local space values (0,1).
void | convertTerrainToImageSpace (Real x, Real y, size_t *outX, size_t *outY)
| Convert terrain space values (0,1) to image space (0, imageSize).
void | convertUVToImageSpace (Real x, Real y, size_t *outX, size_t *outY)
| Convert local space values (0,1) to image space (0, imageSize).
void | convertUVToWorldSpace (Real x, Real y, Vector3 *outWorldPos)
| Helper method - convert a point in local space to worldspace based on the terrain settings.
void | convertWorldToUVSpace (const Vector3 &worldPos, Real *outX, Real *outY)
| Helper method - convert a point in world space to UV space based on the terrain settings.
void | dirty ()
| Indicate that all of the blend data is dirty and needs updating.
void | dirtyRect (const Rect &rect)
| Indicate that a portion of the blend data is dirty and needs updating.
float * | getBlendPointer ()
| Get a pointer to the whole blend data.
float | getBlendValue (uint32 x, uint32 y)
| Get a single value of blend information, in image space.
uint8 | getLayerIndex () const
| Get the index of the layer this is targeting.
Terrain * | getParent () const
| Get the parent terrain.
void | loadImage (const Image &img)
| Load an image into this blend layer.
void | loadImage (const String &filename, const String &groupName)
| Load an image into this blend layer.
void | loadImage (DataStreamPtr &stream, const String &ext=BLANKSTRING)
| Load an image into this blend layer.
void | setBlendValue (uint32 x, uint32 y, float val)
| Set a single value of blend information (0 = transparent, 255 = solid).
void | update ()
| Publish any changes you made to the blend data back to the blend map.

## Detailed Description

Class exposing an interface to a blend map for a given layer.

Each layer after the first layer in a terrain has a blend map which expresses how it is alpha blended with the layers beneath. Internally, this blend map is packed into one channel of an RGBA texture in order to use the smallest number of samplers, but this class allows a caller to manipulate the data more easily without worrying about this packing. Also, the values you use to interact with the blend map are floating point, which gives you full precision for updating, but in fact the values are packed into 8-bit integers in the actual blend map.

  You shouldn't construct this class directly, use Terrain::getLayerBlendMap().

## Constructor & Destructor Documentation

## TerrainLayerBlendMap()

Ogre::TerrainLayerBlendMap::TerrainLayerBlendMap | ( | Terrain * | parent,
|  | uint8 | layerIndex,
|  | HardwarePixelBuffer * | buf )

Constructor.

Parameters

  parent | The parent terrain
  layerIndex | The layer index (should be 1 or higher)
  buf | The buffer holding the data

## ~TerrainLayerBlendMap()

virtual Ogre::TerrainLayerBlendMap::~TerrainLayerBlendMap | ( |  | ) |

virtual

## Member Function Documentation

## getParent()

Terrain * Ogre::TerrainLayerBlendMap::getParent | ( |  | ) | const

inline

Get the parent terrain.

## getLayerIndex()

uint8 Ogre::TerrainLayerBlendMap::getLayerIndex | ( |  | ) | const

inline

Get the index of the layer this is targeting.

## convertWorldToUVSpace()

void Ogre::TerrainLayerBlendMap::convertWorldToUVSpace | ( | const Vector3 & | worldPos,
|  | Real * | outX,
|  | Real * | outY )

Helper method - convert a point in world space to UV space based on the terrain settings.

Parameters

  worldPos | World position
  outX,outY | Pointers to variables which will be filled in with the local UV space value. Note they are deliberately signed Real values, because the point you supply may be outside of image space and may be between texels. The values will range from 0 to 1, top/bottom, left/right.

## convertUVToWorldSpace()

void Ogre::TerrainLayerBlendMap::convertUVToWorldSpace | ( | Real | x,
|  | Real | y,
|  | Vector3 * | outWorldPos )

Helper method - convert a point in local space to worldspace based on the terrain settings.

Parameters

  x,y | Local position, ranging from 0 to 1, top/bottom, left/right.
  outWorldPos | Pointer will be filled in with the world space value

## convertUVToImageSpace()

void Ogre::TerrainLayerBlendMap::convertUVToImageSpace | ( | Real | x,
|  | Real | y,
|  | size_t * | outX,
|  | size_t * | outY )

Convert local space values (0,1) to image space (0, imageSize).

## convertImageToUVSpace()

void Ogre::TerrainLayerBlendMap::convertImageToUVSpace | ( | size_t | x,
|  | size_t | y,
|  | Real * | outX,
|  | Real * | outY )

Convert image space (0, imageSize) to local space values (0,1).

## convertImageToTerrainSpace()

void Ogre::TerrainLayerBlendMap::convertImageToTerrainSpace | ( | size_t | x,
|  | size_t | y,
|  | Real * | outX,
|  | Real * | outY )

Convert image space (0, imageSize) to terrain space values (0,1).

## convertTerrainToImageSpace()

void Ogre::TerrainLayerBlendMap::convertTerrainToImageSpace | ( | Real | x,
|  | Real | y,
|  | size_t * | outX,
|  | size_t * | outY )

Convert terrain space values (0,1) to image space (0, imageSize).

## getBlendValue()

float Ogre::TerrainLayerBlendMap::getBlendValue | ( | uint32 | x,
|  | uint32 | y )

Get a single value of blend information, in image space.

Parameters

  x,y | Coordinates of the point of data to get, in image space (top down)

Returns
  The blend data

## setBlendValue()

void Ogre::TerrainLayerBlendMap::setBlendValue | ( | uint32 | x,
|  | uint32 | y,
|  | float | val )

Set a single value of blend information (0 = transparent, 255 = solid).

Parameters

  x,y | Coordinates of the point of data to get, in image space (top down)
  val | The blend value to set (0..1)

## getBlendPointer()

float * Ogre::TerrainLayerBlendMap::getBlendPointer | ( |  | ) |

Get a pointer to the whole blend data.

This method allows you to get a raw pointer to all the blend data, to update it as you like. However, you must then call dirtyRect manually if you want those changes to be recognised.

## dirty()

void Ogre::TerrainLayerBlendMap::dirty | ( |  | ) |

Indicate that all of the blend data is dirty and needs updating.

## dirtyRect()

void Ogre::TerrainLayerBlendMap::dirtyRect | ( | const Rect & | rect | ) |

Indicate that a portion of the blend data is dirty and needs updating.

Parameters

  rect | Rectangle in image space

## blit() [1/2]

void Ogre::TerrainLayerBlendMap::blit | ( | const PixelBox & | src,
|  | const Box & | dstBox )

Blits a set of values into a region on the blend map.

Parameters

  src | PixelBox containing the source pixels and format
  dstBox | Box describing the destination region in this map

Remarks
  The source and destination regions dimensions don't have to match, in which case scaling is done.

Note
  You can call this method in a background thread if you want. You still need to call update() to commit the changes to the GPU.

## blit() [2/2]

void Ogre::TerrainLayerBlendMap::blit | ( | const PixelBox & | src | ) |

Blits a set of values into the entire map.

The source data is scaled if needed.

Parameters

  src | PixelBox containing the source pixels and format

Note
  You can call this method in a background thread if you want. You still need to call update() to commit the changes to the GPU.

## loadImage() [1/3]

void Ogre::TerrainLayerBlendMap::loadImage | ( | const Image & | img | ) |

Load an image into this blend layer.

## loadImage() [2/3]

void Ogre::TerrainLayerBlendMap::loadImage | ( | DataStreamPtr & | stream,
|  | const String & | ext = BLANKSTRING )

Load an image into this blend layer.

Parameters

  stream | Stream containing the image data
  ext | Extension identifying the image type, if the stream data doesn't identify

References Ogre::BLANKSTRING.

## loadImage() [3/3]

void Ogre::TerrainLayerBlendMap::loadImage | ( | const String & | filename,
|  | const String & | groupName )

Load an image into this blend layer.

## update()

void Ogre::TerrainLayerBlendMap::update | ( |  | ) |

Publish any changes you made to the blend data back to the blend map.

Note
  Can only be called in the main render thread.

The documentation for this class was generated from the following file:

- OgreTerrainLayerBlendMap.h